<?php
namespace Stub;
use Model\Activity;
use Model\IGenericRepository;
use Model\IActivityRepository;
class ActivityRepository implements IActivityRepository, IGenericRepository
{
    public array $Activities = [];
    public function __construct()
    {
        // Ajout de 5 activités pour l'exemple
        $this->Activities[] = new Activity(1, "Course", "Course à pied", "Sport", "2023-10-16", "08:00", "09:00", 5, 5, 5, 2, 50, 100, 10, 25);
        $this->Activities[] = new Activity(2, "Natation", "Natation en piscine", "Sport", "2023-10-17", "10:00", "11:00", 4, 5, 5, 2, 55, 95, 20, 24);
        $this->Activities[] = new Activity(3, "Vélo", "Vélo en montagne", "Sport", "2023-10-18", "14:00", "15:30", 6, 4, 4, 2, 45, 90, 15, 23);
        $this->Activities[] = new Activity(4, "Marche", "Marche en forêt", "Loisir", "2023-10-19", "11:00", "12:00", 3, 4, 4, 2, 60, 85, 40, 22);
        $this->Activities[] = new Activity(5, "Yoga", "Séance de yoga", "Sport", "2023-10-20", "16:00", "17:00", 2, 3, 3, 1, 70, 80, 65, 21);
    }
    public function getHeartRateDataByUserId(int $userId): array
    {
        return;
    }
    public function getItemById(int $id): ?Activity {
        foreach ($this->Activities as $activity) {
            if ($activity->ID_Activite === $id) {
                return $activity;
            }
        }
        return null;
    }

    public function GetNbItems(): int {
        return count($this->Activities);
    }

    public function GetItems(int $index, int $count, ?string $orderingPropertyName = null, bool $descending = false): array {
        return array_slice($this->Activities, $index, $count);
    }

    public function GetItemsByName(string $substring, int $index, int $count, ?string $orderingPropertyName = null, bool $descending = false): array {
        $filteredActivities = array_filter($this->Activities, function ($activity) use ($substring) {
            return strpos(strtolower($activity->name), strtolower($substring)) !== false;
        });
        return array_slice($filteredActivities, $index, $count);
    }

    public function GetItemByName(string $substring, int $index, int $count, ?string $orderingPropertyName = null, bool $descending = false): array {
        return $this->GetItemsByName($substring, $index, $count, $orderingPropertyName, $descending)[0];
    }

    public function UpdateItem(Activity $oldItem, Activity $newItem): void {
        $index = array_search($oldItem, $this->Activities);
        if ($index !== false) {
            $this->Activities[$index] = $newItem;
        }
    }

    public function AddItem(Activity $item): void {
        $this->Activities[] = $item;
    }

    public function DeleteItem(Activity $item): bool {
        $index = array_search($item, $this->Activities);
        if ($index !== false) {
            unset($this->Activities[$index]);
            return true;
        }
        return false;
    }
}


?>